define('mdict-parseXml', function() {
  return function (str) {
    return (new DOMParser()).parseFromString(str, 'text/xml');
  };
});

require(['jquery', 'mdict-parser', 'mdict-renderer', 'mdict-data'], function($, MParser, MRenderer, MData) {
  MParser(MData.fileList).then(function(resources) {
    MData.fileList = [];
    document.mdict = MRenderer(resources);
    function btnClicked(e) {
      $('#definition').empty();
      var word = $('#word').val();
      var lookup = document.mdict.lookup(word)
        .then(content => content, reason => '');
      var fallbackLookup = document.mdict.search({phrase: word})
        .then(result => document.mdict.lookup(result[0]))
        .then(content => new Promise(resolve => setTimeout(() => resolve(content), 100)));
      Promise.race([lookup, fallbackLookup])
        .then(content => {
          document.lookupStatus =  content ? 1 : 0;
          document.mdict.render($('#definition').empty().html(content));
        });
    }
    $('#btn').on('click', btnClicked);

    $('#definition').on('click', 'a', function(e) {
      var href = $(this).attr('href');
      if (href && href.substring(0, 8) === 'entry://') {
        var word = href.substring(8);
        // TODO: remove '#' to get jump target
        if (word.charAt(0) !== '#') {
          word = word.replace(/(^[/\\])|([/]$)/, '');

          $('#word').val(word);
          $('#btn').click();
        } else {
          var currentUrl = location.href;
          location.href = word;                         //Go to the target element.
          history.replaceState(null, null, currentUrl); //Don't like hashes. Changing it back.        
        }
        return false;
      }
    });

  });
});